/* jshint node: true, loopfunc: true, undef: true, unused: true */
///* global */

var Middleware = require('zfinder-middleware');
var path = require('path');
var sprintf = require('zero-fmt/sprintf');
var zfinderUtils = require('zfinder-utils');

var defaultConfig = zfinderUtils.loadYamlConfig(path.resolve(__dirname, '../config.yaml'));

function fillProperties(instance, options) {
    instance.priority = options.priority;
    instance.name = sprintf('%s:%s', options.name, instance.method);
}

var routeInitOptions = {
    defaultConfig: defaultConfig,
    fillProperties: fillProperties
};

module.exports = new Middleware()
    .addRoute(require('./route/create.js')(routeInitOptions))
    .addRoute(require('./route/read.js')(routeInitOptions))
    .addRoute(require('./route/write.js')(routeInitOptions))
    .addRoute(require('./route/delete.js')(routeInitOptions));

