
/* jshint node: true, loopfunc: true, undef: true, unused: true */

var Route = require('zfinder-route');
var objectUtils = require('zero-lang/object');
var path = require('path');
var shelljs = require('shelljs');

module.exports = function(initOptions) {
    return new Route({
        // properties
        method: 'delete', // all|get|post|put|delete|options
        url: '*',
        // methods
        serve: function(options, serverConfig) {
            options = objectUtils.extend({}, initOptions.defaultConfig, options);
            initOptions.fillProperties(this, options);
            var root = serverConfig.root;

            return function(req, res, next) {
                var params = req._params;
                if (params._mw === options.name) {
                    /*
                     * params:
                     *     _mw: zfinder-mw-fs
                     *     type: file
                     *     content: $content
                     */
                    var pathname = decodeURIComponent(req._urlInfo.pathname);
                    try {
                        shelljs.rm('-rf', path.join(root, pathname));
                        res._JSONRes({
                            success: true
                        });
                    } catch(err) {
                        next(err);
                    }
                } else {
                    next();
                }
            };
        }
    });
};
